# Procédure d'installation

GTF dispose d’un installateur spécifique VAI qui permet d’assurer l’installation et la mise à jour du produit sans perte de configuration ni de données.

## 1. Préconisations techniques

<table align="center" class="docutils" border="1">
<thead valign="middle" align="center">
  <tr class="row-odd">
   <td>
   <b>Poste</b>
   </td>
   <td>
   <b>Configuration minimale</b>
   </td>
   <td>
   <b>Configuration recommandée</b>
   </td>
  </tr>
</thead>

<tbody valign="middle">
<tr class="row-even">
 <td>
 CPU
 </td>
 <td>
 2 coeurs
 </td>
 <td>
 4 coeurs
 </td>
</tr>

<tbody valign="middle">
<tr class="row-even">
 <td>
 Mémoire vive
 </td>
 <td>
 4 GB (8Gb sur un système 64-bit)
 </td>
 <td>
 8 GB (16Gb sur un système 64-bit)
 </td>
</tr>

<tr class="row-odd">
 <td>
 Espace disque disponible
 </td>
 <td>
 8 GB
 </td>
 <td>
 60 GB
 </td>
</tr>

<tr class="row-even">
 <td>
 Base de données
 </td>
 <td>
 PostgreSql 9.3 ou plus
 </td>
 <td>
 PostgreSql 9.3 ou plus
 </td>
</tr>

<tr class="row-odd">
  <td>
  Serveur http
  </td>
  <td>
    Apache 2.4.13 ou plus (avec mod_ssl)
  </td>
  <td>
    Apache 2.4.13 ou plus (avec mod_ssl)
  </td>
</tr>
</tbody>
</table>

## 2. Installation des prérequis

### Installation de FME

Dans GTF, FME est en charge de l’exécution des projets.
Procéder en premier lieu à l'installation de FME pour que GTF puisse fonctionner et exécuter des traitements.

[Procédure d'installation de FME en Anglais](https://docs.safe.com/fme/html/FME_Desktop_Documentation/FME_Desktop_Admin_Guide/FMEInstallation/Installing-FME-Desktop.htm)

[Procédure d'installation de FME en Français](https://www.veremes.com/wp-content/uploads/fme_guide_installation-1.pdf)

Si vous utilisez une version Oracle de FME, il faudra installer le client Oracle sur le serveur.

### Installation du serveur https Apache 2.4

GTF utilise le protocole sécurisé https qui assure le cryptage des échanges entre le Serveur d’Application Vitis et le poste client. Il est donc nécessaire d’installer une version spécifique du serveur http Apache compilé avec le module SSL.

[Procédure d’installation Apache 2.4 pour Windows](http://www.veremes.com/installation-apache-2-4-mod_ssl-windows)

[Procédure d’installation Apache 2.4 pour Linux](https://www.veremes.com/installation-apache-2-4-linux)

### Installation de Postgresql

GTF utilise une base Postgresql pour stocker les informations sur les projets FME et les demandes de traitement ainsi que sur les utilisateurs et leurs droits. Si Postgresql est déjà installé sur votre poste, cette étape est facultative.

[Procédure d’installation Postgresql pour Windows](http://www.veremes.com/installation-postgresql-windows)

[Procédure d’installation Postgresql pour Linux](https://www.veremes.com/installation-postgresql-linux)

## 3. Installation de GTF

Pour installer GTF, éditez le fichier install.cmd (Windows) ou install.sh (Linux) afin de définir les paramètres de votre installation.

Les variables à modifier pour l’installation sont :

<table align="center" class="docutils" border="1">
<thead valign="middle" align="center">
  <tr class="row-odd">
   <td>
   <b>Variable</b>
   </td>
   <td>
   <b>Description</b>
   </td>
  </tr>
</thead>

<tbody valign="middle">
<tr class="row-even">
 <td>
 dir
 </td>
 <td>
 Répertoire d'installation (/var/www/gtf préférable pour Linux C:/server/gtf conseillé pour Windows)
 </td>
</tr>

<tr class="row-odd">
 <td>
 serveur
 </td>
 <td>
 Serveur de la base de données
 </td>
</tr>

<tr class="row-even">
 <td>
 port
 </td>
 <td>
 Port d'accès à la base de données
 </td>
</tr>

<tr class="row-odd">
  <td>
  bdd
  </td>
  <td>
  Nom de la base de données (La base de données peut être existante)
  </td>
</tr>

<tr class="row-odd">
  <td>
  dblogin
  </td>
  <td>
  Compte d'un superutilisateur de la base
  </td>
</tr>

<tr class="row-odd">
  <td>
  dbpswd
  </td>
  <td>
  Mot de passe du compte superutilisateur
  </td>
</tr>

<tr class="row-odd">
  <td>
  apacheService
  </td>
  <td>
  Nom du service Apache exploité par l'application
  </td>
</tr>

<tr class="row-odd">
  <td>
  apachePort
  </td>
  <td>
  Port du service https du serveur Apache
  </td>
</tr>

<tr class="row-odd">
  <td>
  appAdmin
  </td>
  <td>
  Compte PostgreSql de l'administrateur de l'application. Ce compte sera créé s'il n'existe pas.
  </td>
</tr>

<tr class="row-odd">
  <td>
  appPswd
  </td>
  <td>
  Mot de passe du compte précédent s'il doit être créé. Si le compte existe déjà cette valeur n'est pas exploitée. Il faut néammoins saisir une valeur car ce paramètre est obligatoire.
  </td>
</tr>
</tbody>
</table>

L’installateur de GTF assure les opérations suivantes :
- Copie du code du serveur d’application Vitis
- Copie du code du moteur GTF
- Installation et configuration de Pycron comme un service (Uniquement sur Windows)
- Installation du PHP
- Configuration du serveur HTTPS Apache
- Création de la base de données dans PostgreSQL
- Création d’un compte administrateur dans PostgreSQL

![](../doc_module_gtf/images/icones/warning.png)
Sur Linux, donner les droits d’exécution aux fichiers install.sh et setup_gtf-[version_gtf].[build_gtf].
```
chmod +x setup_gtf-[version_gtf].[build_gtf]
```

Exécutez le script install.cmd ou install.sh pour lancer l’installation.

![](../doc_module_gtf/images/icones/warning.png)
Sur Windows, il faut attendre une minute environ pour avoir un retour dans la console.

Un rapport d’installation install_report_dd-mm-yyyy.txt est généré, il permet de savoir si l’installation s’est déroulée correctement.

## 4. Configuration de PostgreSQL

Il est nécessaire de configurer le serveur PostgreSQL pour permettre à l’application d’accéder à la base de données.

*La procédure ci-dessous s’applique si le serveur PostgreSQL est sur la même machine que GTF. Si ce n’est pas le cas, il faut prévoir une configuration spécifique.*

1. Editez le fichier pg_hba.conf de PostgreSQL :

    Immédiatement après « # IPv4 local connections » insérez la ligne :

    ```
    # IPv4 local connections
    host gtfdatabase u_vitis 127.0.0.1/32 trust
    host gtfdatabase u_scheduler 127.0.0.1/32 trust
    ```

    Immédiatement après « # IPv6 local connections » insérez la ligne :

    ```
    # IPv6 local connections
    host gtfdatabase u_vitis ::1/128 trust
    host gtfdatabase u_scheduler ::1/128 trust
    ```

2. Redémarrez le service PostgreSQL

## 5. Test de l'installation de GTF

L' instance de GTF doit désormais être disponible à l’adresse :

**https://[serveur]/gtf**

Où <serveur> est l’adresse de la machine où vous avez installé l’application.

![](../doc_module_gtf/images/icones/warning.png)
 La connexion à GTF par l’adresse localhost est impossible

![](../doc_module_gtf/images/icones/question_small.png)
Note : si vous vous connectez avec le protocole http, la connexion sera automatiquement redirigée vers https.

Si vous avez créé vous-même votre propre certificat, votre serveur n’est pas sécurisé et votre navigateur va sans doute afficher un message d’alerte.

<div style="text-align:center;margin-bottom:20px;"><img src ="../doc_module_gtf/images/erreur_https.png" /></div>

Vous devrez créer une exception de sécurité dans votre navigateur avant de pouvoir accéder à votre site.

Si vous utilisez un certificat valide ou si vous avez créé une exception de sécurité, vous devez arriver à la page de connexion :

![](../doc_module_gtf/images/connexion-gtf.png)

Vous pouvez vous connecter en utilisant le compte et le mot de passe définis pendant l’installation.

La première chose à faire après la connexion est de vous attribuer des privilèges pour vous permettre d’exploiter toutes les fonctions d’administration et d’utilisation de GTF.

Cliquez sur l’icône ![](../doc_module_gtf/images/gtf_users.png) pour passer en mode « Gestion des utilisateurs », choisissez l’onglet « Utilisateurs » (activé par défaut) et éditez votre compte.
- Attribuez les privilèges : gtf_admin et gtf_user à l’utilisateur
- Attribuez le groupe Administration à l’utilisateur

![](../doc_module_gtf/images/gtf_groups.png)

Vous disposez maintenant de tous les droits pour administrer et utiliser GTF. Reconnectez-vous pour accéder aux nouvelles fonctionnalités.

## 6. Configuration de GTF

### 1. Configuration Générale

Cliquez sur l’icône ![](../doc_module_gtf/images/gtf_configuration.png) pour passer en mode « Configuration ».

Il est préférable de configurer un serveur SMTP pour pouvoir utiliser GTF.

![](../doc_module_gtf/images/gtf_config-smtp.png)

![](../doc_module_gtf/images/icones/warning.png)
Il faut sauvegarder la configuration avant de pouvoir la tester.

![](../doc_module_gtf/images/icones/warning.png)
Si vous avez créé vous-même votre propre certificat désactivez l’option « Vérifier la validité du certificat SSL ».

### 2. Activation de votre licence GTF

Toujours dans le mode configuration, cliquez sur la section "licence" pour demander/activer votre licence GTF.

Si vous n'avez pas de license GTF vous pouvez envoyer un mail à l'adresse [codes@veremes.com](mailto:codes@veremes.com), ou cliquer sur le bouton "Demander le fichier de licence" (à condition d'avoir configurer un serveur SMTP).

Si vous avez un fichier de licence GTF vous pouvez l'activer via le formulaire de cette section.

![](../doc_module_gtf/images/gtf_license.png)

### 3. Création d'un moteur GTF

Cliquez sur l’icône ![](../doc_module_gtf/images/gtf_engines.png) pour pouvoir gérer vos moteurs. Cliquez sur l'objet serveur.

La déclaration du serveur permet de définir les répertoires contenant l’ordonnanceur Pycron et le moteur GTF.

Par défaut le serveur localhost sera défini, il fonctionnera pour une installation classique de GTF.

 ![Déclaration de serveur](../doc_module_gtf/images/ajout_serveur.png)

Ensuite il faut définir vos moteurs FME. Pour ça, cliquez sur l'objet moteur FME du même mode.

Un moteur FME est l'instance de FME en charge de l'exécution des projets. GTF permet d'exploiter différents moteurs hétérogènes. On peut ainsi exploiter un moteur FME 2015 en 32 bits et une instance de FME 2016 en 64 bits.

**A partir de la version 2019.01.00 de GTF**, il est aussi possible d'exploiter une instance FME Serveur et/ou FME Cloud. Cette fonctionnalité sera documenter en détail dans la partie Administration.

La première étape consiste à déclarer un moteur FME exploitable par GTF.

 ![Déclaration de moteur FME](../doc_module_gtf/images/gtf_fme_engines.png)

 ![](../doc_module_gtf/images/icones/idea.png) Il est conseillé de nommer le moteur FME en indiquant le numéro de version, le numéro de build et le nombre de bits. Par exemple : « FME2016 b16494-32b ».

 ![](../doc_module_gtf/images/icones/check.png) Le bouton 'Test' permet de vérifier la validité de la licence FME. Avec FME 2016, pour que la licence soit valide, copier le fichier de licence présent dans le répertoire C:\ProgramData\SafeSoftware\FME\Licenses) dans le répertoire \licenses du répertoire d'installation de FME2016.

![](../doc_module_gtf/images/icones/warning.png)
 Sur Linux, si vous voulez utiliser FME 2018 ou supérieur, il faut exécuter ce script :
```
cd /opt/fme-desktop-2018/metafile
sudo cp *.fmi ./dependencies/
sudo cp *.fmf ./dependencies/
```

Il faut encore créer un moteur GTF.

On entend par Moteur GTF la capacité d'exploiter un moteur FME dans GTF. La création d'un moteur GTF permet d'associer à un serveur un moteur et de définir une période de déclenchement de l'activité spécifique. Un moteur GTF est associé à un seul moteur FME mais plusieurs moteurs GTF peuvent exploiter le même moteur FME.

L'ajout de moteurs GTF supplémentaires permet à l'administrateur d'appliquer une stratégie de traitement de projets en spécialisant par exemple certains moteurs et en permettant la parallélisation des traitements.

cliquez sur l'objet moteur GTF du même mode et cliquez sur le bouton « Ajouter un moteur GTF » pour ouvrir le formulaire de création  de moteur GTF.

Attribuer un nom au moteur GTF et définir la période d'activité en minutes de ce dernier (période de déclenchement du moteur). On peut choisir de rendre inactif ce moteur, puis on sélectionne le serveur et le moteur FME à associer. Associer ensuite un ou plusieurs mots clés au moteur.

 ![Déclaration de moteur GTF](../doc_module_gtf/images/gtf_engines_gtf.png)



 ![](../doc_module_gtf/images/icones/idea.png) Associer un ou plusieurs mots clés à un moteur permet à l'administrateur de mettre en place une stratégie de distribution des traitements sur plusieurs moteurs GTF : quand un utilisateur crée une demande de traitement, un moteur spécifique est spécifiquement attribué. Chaque moteur GTF est associé à un ou plusieurs mots clés. Chaque projet FME est ensuite associé à un mot clé. L'affiliation d'un projet à un moteur GTF se fait ainsi à partir de mots clés.
 L'administrateur peut choisir des mots clés existants et déjà affiliés à d'autres moteurs dans la partie de gauche 'Mots clés disponibles', ou saisir directement le nom d'un nouveau mot clé dans le bloc de droite 'Mot clé lié au moteur'. Un simple clic sur un mot clé disponible permet de le lier au moteur GTF.


 ![](../doc_module_gtf/images/icones/check_small.png) Il est recommandé de nommer le moteur GTF selon cette règle : ID (auto) FME Version Service Pack. Par exemple : «  #3 FME 2013 SP 3 ».

Cliquer ensuite sur le bouton “Créer” pour finaliser la création du moteur GTF.

### 4. Test du moteur GTF

A ce stade, pour s'assurer du bon fonctionnement de GTF, il est recommandé de procéder à l'import de nouveaux traitements. Pour cela, Veremes met à disposition sur son site de téléchargement [vStore](https://vstore.veremes.net/store) un projets exemples au format .gex ou .fmw.

Vous pouvez aussi ajouter un de vos propre projet via le mode "Publication".

Le projet 'Admin\_Import' (associé au groupe Administration et installé automatiquement lors de l'installation de GTF) permet l'import de nouveaux traitements stockés dans un fichier .gex. Au préalable, l'administrateur doit être associé au groupe Administration pour pouvoir exploiter ces deux projets.

Se connecter à GTF (compte administrateur) puis ajouter une demande.

 ![Import du fichier d'exemples.](../doc_module_gtf/images/formulaire_import.png)

Choisir le traitement "Admin-Import" puis dans « Fichier d'export GTF à importer (.gex) : », cliquer sur « Parcourir » et sélectionner le fichier .gex préalablement téléchargé. Définir ensuite le nom du rapport html à générer. Il indique la liste des projets importés, leurs clé et ID ainsi que le statut de l'importation : Inséré dans GTF, Mis à jour dans GTF ou Non mis à jour dans GTF.

 ![](../doc_module_gtf/images/icones/idea.png) Associer un ou plusieurs mots clés à un moteur permet à l'administrateur de mettre en place une stratégie de distribution des traitements sur plusieurs moteurs GTF : quand un utilisateur crée une demande de traitement, un moteur spécifique est spécifiquement attribué. Chaque moteur GTF est associé à un ou plusieurs mots clés. Chaque projet FME est ensuite associé à un mot clé. L'affiliation d'un projet à un moteur GTF se fait ainsi à partir de mots clés.Il est obligatoire d'insérer l'extension .html dans le champs Nom du rapport à générer.

 ![](../doc_module_gtf/images/icones/check_small.png) Le paramètre 'Que faire des projets existants déjà dans la base GTF (même Clé)' indique à GTF s'il doit charger ou pas les projets déjà existants dans la base GTF et identifiés de façon unique  par l'attribut Clé (cet attribut est généré automatiquement et est associé de façon unique à chaque projet).

 - Si ce paramètre vaut 'Ne pas importer' et que le fichier .gex contient un projet FME avec une clé déjà existante dans la base GTF, alors le fichier n'est pas chargé.
 - Inversement, si ce paramètre vaut 'Remplacer les projets existants', alors les projets dont la clé existe déjà dans la base de données GTF seront écrasés.
 - Choisir 'Importer le projet avec un nouvel identifiant et un nouveau nom', si le projet FME avec la même clé existe déjà en base et que vous souhaitez importer le même projet mais avec un nouveau nom. Le projet est renommé en étant suffixé par la chaîne '(import date de l'import)'.


 Cliquer  sur « Créer la demande ». La demande est prise en compte et se retrouve dans la file d'attente du moteur GTF.

 S'assurer que la Demande ait bien été traitée en consultant le mode Supervision, puis retourner dans le mode Publication pour consulter la liste des traitements nouvellement importés.


## 6. Import des traitements d'administration

 Le projet 'Nettoyage des fichiers temporaires' est disponible sur notre site de téléchargement. Il permet les fonctions d'administration suivantes :

 - le nettoyage des fichiers temporaires stockés dans les répertoires temporaires de GTF et FME.


 Pour importer ce fichier, procéder de la même manière que précédemment en téléchargeant sur le site [vStore](https://vstore.veremes.net/store) (répertoire gtf/gex) la ressource Cleaner.


 Se connecter ensuite à GTF et faire une demande du Traitement Admin-Import. Choisir le fichier précédemment téléchargé.
 Assurez-vous que dans le mode Publication, ce nouveau traitement ait bien été importé.

 L'administrateur peut procéder à la configuration spécifique de GTF en définissant le compte public, et mettant en place une stratégie de sécurité utilisateur.

 Il créé ensuite les utilisateurs et/ou les importe depuis un annuaire Active Directory.
